BOM field names and sorting

Bug #581153 reported by Karl Schmidt on 2010-05-16
36
This bug affects 6 people
Affects Status Importance Assigned to Milestone
KiCad
Fix Released
Low
Dick Hollenbeck

Bug Description

Creating and moving custom Field names of Library parts works well (Thanks). But creating a BOM ends up with the default field names instead of the custom ones in the header:

With the following settings:

checked - Components by Reference
Selected - Output format = Text for spreadsheet
Field sep = tab
Checked - System fields - footprint
Checked - All existing users fields

The header is :
ref value footprint Field1 Field2 Field3 Field4 Field5 Field6 Field7 Field8

This also creates a BOM that is sorted by the Fx Field list number instead of being sorted by the custom field names.

This is related, but not the same as the problem Brian worked out a patch for - I worked around the same limitation by creating a template part - but ended up changing the order of the fields in lib edit Fields properties dialog by pressing "move up" . Thus if one of the custom field names is "Price" and it is in F8 for one part but F9 in another the BOM is rather scambled.

At this point there are lots of custom field names in use in various order so I think it would be good to sort the report by the custom field name when it is generated.

This is on Build: (2010-05-11 BZR 2372)-unstable

Changed in kicad:
assignee: nobody → Dick Hollenbeck (dickelbeck)
Stephen Eaton (seaton) wrote :

changing status to in-progress as I know Dick is working on this (please correct me if I'm wrong)

Changed in kicad:
status: New → In Progress
Stephen Eaton (seaton) on 2010-07-05
Changed in kicad:
importance: Undecided → Medium

I have same problem with (2012-01-19 BZR 3256)-stable and Windows XP.

I perform text output format for spreadsheet import and select (;) for field separator. Kicad does correctly the spreadsheet separating fields by columns, but columns haven't his custom name and aren't in order.

Thanks.

When I create a list of items (BOM) is not user field 8 ("Field 8" or "All existing user fields" checked).

Patch was attached.

Application: Eeschema
Version: (2013-mar-13 GOST)-testing
Build: wxWidgets 2.8.12 (no debug,Unicode,compiler with C++ ABI 1002,GCC 4.7.2,wx containers,compatible with 2.6)
Platform: Linux 3.8.0-030800-generic i686, 32 bit, Little endian, wxGTK
Boost version: 1.53.0
Options: USE_PCBNEW_NANOMETRES=ON
         KICAD_GOST=ON
         USE_WX_GRAPHICS_CONTEXT=OFF
         USE_WX_OVERLAY=OFF
         KICAD_SCRIPTING=ON
         KICAD_SCRIPTING_MODULES=ON
         KICAD_SCRIPTING_WXPYTHON=OFF

Le 27/03/2013 09:53, Baranovskiy Konstantin a écrit :
> When I create a list of items (BOM) is not user field 8 ("Field 8" or
> "All existing user fields" checked).
>
> Patch was attached.

Committed with other changes. Thanks.

--
Jean-Pierre CHARRAS

Stefan Helmert (stefan-helmert) wrote :

Bug not solved - on version 2013-03-31:

- empty user fields are collapst in the BOM
- datasheet doubled in first user field
- the exclusion of (,),... means not all URLs are possible for datasheet
- field-names of user fields are field1, field2 ... instead of the user defined field name

on grouped refs.:
- if two components are grouped - comma leads to separation as different fields

list by value
- field names not shown

show in editor:
- if show in editor option is enabled in choosing the editor is canceled, messages shows that editor <> was not found

Dick Hollenbeck (dickelbeck) wrote :

Why not use the pyyhon bom generator? We have decided to drop support for
the c++ vesion anyway.
On Apr 6, 2013 6:20 PM, "Stefan Helmert" <email address hidden> wrote:

> Bug not solved - on version 2013-03-31:
>
> - empty user fields are collapst in the BOM
> - datasheet doubled in first user field
> - the exclusion of (,),... means not all URLs are possible for datasheet
> - field-names of user fields are field1, field2 ... instead of the user
> defined field name
>
> on grouped refs.:
> - if two components are grouped - comma leads to separation as different
> fields
>
> list by value
> - field names not shown
>
> show in editor:
> - if show in editor option is enabled in choosing the editor is canceled,
> messages shows that editor <> was not found
>
> --
> You received this bug notification because you are a bug assignee.
> https://bugs.launchpad.net/bugs/581153
>
> Title:
> BOM field names and sorting
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/kicad/+bug/581153/+subscriptions
>

Just to continue the pain of this bug/feature. One of the fields is missing completely... the "F 3" document. Of all the fields, this is maybe one of the most important as I like to have design reviews and validate work and its nice to have the documents accompany the symbols and footprints when doing this. Presently I've written perl scripts to do this, running on the *.sch files (up and down the sheets). But last time I checked, I thought the python cls only worked on brd files and the api looked very limited. I like the idea of having more python scripting abilities!

Dick Hollenbeck (dickelbeck) wrote :

On Apr 9, 2013 3:36 PM, "Richard Howlett" <email address hidden> wrote:
>
> Just to continue the pain of this bug/feature. One of the fields is
> missing completely... the "F 3" document. Of all the fields, this is
> maybe one of the most important as I like to have design reviews and
> validate work and its nice to have the documents accompany the symbols
> and footprints when doing this. Presently I've written perl scripts to
> do this, running on the *.sch files (up and down the sheets). But last
> time I checked, I thought the python cls only worked on brd files and
> the api looked very limited. I like the idea of having more python
>

This is not scripting per se, but rather simply running an external program
on generic netlist export in eeschema.

http://bazaar.launchpad.net/~kicad-testing-committers/kicad/testing/files/head:/scripts/bom-in-python/ky/

I will provide more documentation soon.

Also see Eeschema doc, chapter 14 for info about the generic netlist and how to use it.

dhaillant (david-haillant) wrote :

"list by value" is sorted by reference instead.

It works for me. But without any reference to kicad version, a bug report is useless.

On Tue, May 14, 2013 at 05:48:39PM -0000, jean-pierre charras wrote:
> It works for me. But without any reference to kicad version, a bug
> report is useless.

Wasn't also the internal BOMmer deprecated in favour of the python ones?

--
Lorenzo Marcantonio
Logos Srl

Le 15/05/2013 08:10, Lorenzo Marcantonio a écrit :
> On Tue, May 14, 2013 at 05:48:39PM -0000, jean-pierre charras wrote:
>> It works for me. But without any reference to kicad version, a bug
>> report is useless.
>
> Wasn't also the internal BOMmer deprecated in favour of the python ones?
>
It will be, however I need to rewrite the BOM dialog, in order to have
an easy to use BOM python scripts.

--
Jean-Pierre CHARRAS

Dick Hollenbeck (dickelbeck) wrote :

On 05/15/2013 01:28 AM, jean-pierre charras wrote:
> Le 15/05/2013 08:10, Lorenzo Marcantonio a écrit :
>> On Tue, May 14, 2013 at 05:48:39PM -0000, jean-pierre charras wrote:
>>> It works for me. But without any reference to kicad version, a bug
>>> report is useless.
>>
>> Wasn't also the internal BOMmer deprecated in favour of the python ones?
>>
> It will be, however I need to rewrite the BOM dialog, in order to have
> an easy to use BOM python scripts.

We agreed to do that after the last release. The release was made.

Here is an easier to use dialog:

https://answers.launchpad.net/kicad/+faq/2265

The BOM dialog must be configurable, and I don't know how it can be any easier to use
without losing configurability.

No assumptions can be made about whether python or xsltproc is to be used. Either must be
usable. So I don't see any easier way. We've both invested time in the eeschema.pdf file
showing how this is done.

That is good enough in my opinion. I removed the BOM dialog this morning, per prior
agreement, and replaced it with a pointer to the FAQ above. This should hold us until
something easier to use is available. But any external tool must be supported in order to
qualify as easier to use.

Changed in kicad:
status: In Progress → Fix Committed
importance: Medium → Low
Jon Neal (reportingsjr) on 2015-09-26
Changed in kicad:
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers